import csv
from matplotlib import pyplot

def dessine_points(lx, ly, img):
    pyplot.clf()
    pyplot.scatter(lx, ly)
    pyplot.grid()
    pyplot.savefig(img)

#Test Question 1
#dessine_points(range(101), [ 0.5 * x for x in range(101) ], "test1.png")


#Question 2
def dessine_barres(t, img):
    lx = [ 2 * i for i in range(len(t)) ]
    ly = [ p[1] for p in t ]
    lt = [ p[0] for p in t ]
    pyplot.clf()
    pyplot.bar(lx, ly, tick_label=lt)
    pyplot.grid()
    pyplot.savefig(img)


# Test Question 2
dessine_barres([("A", 1), ("B", 2), ("C", 3), ("D", 1)], "test2.png")

# Question 3
f = open("tweets_s.csv")
TWEETS = list(csv.DictReader(f))
for t in TWEETS:
    t["user_followers_count"] = int(t["user_followers_count"])
    t["longitude"] = float(t["longitude"])
    t["latitude"] = float(t["latitude"])
    t["timestamp"] = int(t["timestamp"])
f.close()

#Question 3
def nb_tweets(t):
    return len(t)

# Test Question 3
#print("Nombre de tweets dans le fichier:", nb_tweets(TWEETS))


def long_tweet_time(t):
    lx = [ (d["timestamp"] - 1546300800000) / (3600 * 24 * 1000) for d in t ]
    ly = [ len(d["text"]) for d in t ]
    dessine_points(lx, ly, "ltt.png")

# long_tweet_time(TWEETS)


def nb_tweet_langue(t):
    res = {}
    for d in t:
        if d["lang"] in res:
            res[d["lang"]] += 1
        else:
            res[d["lang"]] = 0

    res100 = [ p for p in res.items() if p[1] > 100 ]
    dessine_barres(res100, "ntp.png")

nb_tweet_langue(TWEETS)
